use rbx_dom_weak::{InstanceBuilder,WeakDom};
use rbx_types::Ref;

pub struct Services{
	pub game:Ref,
	pub workspace:Ref,
}
impl Services{
	pub fn find_in(dom:&WeakDom)->Option<Self>{
		Some(Services{
			workspace:*dom.root().children().iter().find(|&&r|
				dom.get_by_ref(r).is_some_and(|instance|instance.class=="Workspace")
			)?,
			game:dom.root_ref(),
		})
	}
}

pub fn new_place_with_instances_in_workspace(mut instance_dom:WeakDom)->(WeakDom,Services){
	//workspace
	let workspace_bldr=InstanceBuilder::new("Workspace")
		.with_child(InstanceBuilder::new("Terrain"));
	let workspace=workspace_bldr.referent();

	//game
	let game_bldr=
		InstanceBuilder::new("DataModel")
		.with_child(workspace_bldr)
		.with_child(InstanceBuilder::new("Lighting"));
	let game=game_bldr.referent();

	let mut dom=WeakDom::new(game_bldr);

	//put instances in workspace
	let children=instance_dom.root().children().to_owned();
	for instance in children{
		instance_dom.transfer(instance,&mut dom,workspace);
	}

	(
		dom,
		Services{
			game,
			workspace
		}
	)
}
